import type { Predicate } from '../index';
import type { Criterion } from '../utils/convertKeywordToCriterion';
import type { Json } from '../utils/types';
/**
 * Match.
 * @param element - String | number | Record<string, string>.
 * @param criteria - Criterion[].
 * @param predicate - String.
 * @param options - Object.
 * @param options.ignorePaths - RegExp[].
 * @param options.pathAlias - Record<string, string|RegExp>s.
 * @param options.includePaths
 * @returns Boolean.
 */
export default function match(element: Json, criteria: Criterion[], predicate: Predicate, options: {
    ignorePaths: RegExp[];
    includePaths?: RegExp[];
    pathAlias: Record<string, RegExp>;
}): boolean;
//# sourceMappingURL=match.d.ts.map